#include "ioconfig.h"

IOConfig& IOConfig::setInputDir  (const std::string& id) {
    this->inputDir = id;
    return *this;
}

IOConfig& IOConfig::setOutputDir (const std::string& od) {
    this->outputDir = od;
    return *this;
}

IOConfig& IOConfig::setFilenameTemplate (const std::string& fnt) {
    this->filenameTemplate = fnt;
    return *this;
}

IOConfig& IOConfig::setFirstFrameNumber (int ffn) {
    this->first = ffn;
    return *this;
}

IOConfig& IOConfig::setLastFrameNumber (int lfn) {
    this->last = lfn;
    return *this;
}

IOConfig &IOConfig::setOutputBufferSize(unsigned int obs)
{
    this->outputBufferSize = obs;
    return *this;
}

IOConfig& IOConfig::setSaveForegroundPDF (bool sfgpdf) {
    this->saveForegroundPDF = sfgpdf;
    return *this;
}

IOConfig& IOConfig::setSaveBackgroundPDF (bool sbgpdf) {
    this->saveBackgroundPDF = sbgpdf;
    return *this;
}

IOConfig& IOConfig::setSaveForegroundProbability (bool sfgp) {
    this->saveForegroundProbability = sfgp;
    return *this;
}

IOConfig& IOConfig::setSaveForegroundDetection (bool sfd) {
    this->saveForegroundDetection = sfd;
    return *this;
}

IOConfig &IOConfig::setSavePNG(bool savePNG)
{
    this->savePNG = savePNG;
    return *this;
}

IOConfig::IOConfig (const IOConfig& other) :
    inputDir                  (other.inputDir), 
    outputDir                 (other.outputDir),
    filenameTemplate          (other.filenameTemplate),
    first                     (other.first),
    last                      (other.last),
    outputBufferSize          (other.outputBufferSize),
    saveForegroundPDF         (other.saveForegroundPDF),
    saveBackgroundPDF         (other.saveBackgroundPDF),
    saveForegroundProbability (other.saveForegroundProbability),
    saveForegroundDetection   (other.saveForegroundDetection),
    savePNG                   (other.savePNG)
{
    // Not much left to do.
}

std::ostream & operator<< (std::ostream & o, IOConfig io) {
    o << "Input dir: " << io.inputDir << std::endl;
    o << "Output dir: " << io.outputDir << std::endl;
    o << "Filename: " << io.filenameTemplate << " " << io.first << " " << io.last << std::endl;
    o << "Save PNG format: " << (io.savePNG ? "yes" : "no") << std::endl;
    return o;
}


