#ifndef PROCESSINGSTAGECUDA_H
#define PROCESSINGSTAGECUDA_H

#include <cuda_runtime.h>
#include "imagedimensions.h"
#include "processingconfig.h"
#include "thumbnail.h"
#include "processingdatatypes.h"





void bindProcessingSurfaces (cudaArray *inputImageArray,
                             cudaArray *nextStageArray
//                             ,
//                             cudaArray *imageDiffArray,
//                             cudaArray *probArray,
//                             cudaArray *probDiffArray
                             );

template<typename T>
void launchBypass (int width, int height, int inputOffset, int outputOffset, cudaStream_t stream);

template<typename T>
void launchProcess (ProcessingConfig const &config,
                    ImageDimensions  const &imageDim,
                    ProcessingDeviceAux const & deviceAux,
                    ProcessingDeviceData<T> &deviceData,
                    ProcessingHostData      &hostData);




#endif // PROCESSINGSTAGECUDA_H
